const mongoose = require('mongoose');
const express = require('express')
const jimp = require('jimp')
const fs = require('fs')
const app = express()
const port = 80

// DB stuff
const db  = mongoose.connection;
const mongoDBURL = 'mongodb://127.0.0.1/memes';
mongoose.connect(mongoDBURL, { useNewUrlParser: true });
db.on('error', console.error.bind(console, 'MongoDB connection error:'));

var MemeSchema = new mongoose.Schema({
  fileName: String,
  text: String
});    
var Meme = mongoose.model('Meme', MemeSchema );
       

app.use(express.static('public_html'))

app.get('/:template/:top/:bottom', function (req, res) {
  var template = req.params.template;
  var topText = req.params.top;
  var bottomText = req.params.bottom;
  var inputFileName = './images/' + template + '.png'
  var imgFile = Math.floor(Math.random() * 10000) + '.png';
  var outputFileName = './public_html/' + imgFile;

 // update to use promises

  let image = undefined;

  jimp.read(inputFileName).then((img) => {
      image = img;
      return jimp.loadFont(jimp.FONT_SANS_32_WHITE);
  }).then((font) => {
      image.print(font, 10, 10, topText);
      image.print(font, 10, 350, bottomText);
      return image.write(outputFileName);
  }).then((image) => {
      let newMeme = new Meme({ fileName: imgFile, text: topText + ' ' + bottomText });
      return newMeme.save();
  }).then((result) => { 
      res.end('/' + imgFile);
  }).catch((err) => { 
      console.log('yikes!');
      console.log(err);
  });


  let p = chatMessage.save();
  p.then(() => { 
    // what to do when done
  });
  p.catch( () => {
    // what do do if it failed to save
  });

});

app.get('/memes/get', function (req, res) {
  let p = Meme.find({}).exec();
  p.then((documents) => {
    let results = '<html><head></head><body>\n';
    for (let i = 0; i < documents.length; i++) {
      results += '<img src="/' + documents[i].fileName + '" width="200" />\n';
    }
    results += '</body></html>'
    res.end(results);
  });
});

app.listen(port, () => 
  console.log(`App listening at http://localhost:${port}`))
